/*----- PROTECTED REGION ID(TwinApuIdClass.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        TwinApuIdClass.cpp
//
// description : C++ source for the TwinApuIdClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the TwinApuId once per process.
//
// project :     twin-apu-id
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
// Elettra-Sincrotrone Trieste S.C.p.A. di interesse nazionale
// Strada Statale 14 - km 163,5 in AREA Science Park
// 34149 Basovizza, Trieste ITALY
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <TwinApuIdClass.h>

/*----- PROTECTED REGION END -----*/	//	TwinApuIdClass.cpp

//-------------------------------------------------------------------
/**
 *	Create TwinApuIdClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_TwinApuId_class(const char *name) {
		return TwinApuId_ns::TwinApuIdClass::init(name);
	}
}

namespace TwinApuId_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
TwinApuIdClass *TwinApuIdClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		TwinApuIdClass::TwinApuIdClass(string &s)
 * description : 	constructor for the TwinApuIdClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
TwinApuIdClass::TwinApuIdClass(string &s):SupervisedID_ns::SupervisedIDClass(s)
{
	cout2 << "Entering TwinApuIdClass constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(TwinApuIdClass::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuIdClass::constructor

	cout2 << "Leaving TwinApuIdClass constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		TwinApuIdClass::~TwinApuIdClass()
 * description : 	destructor for the TwinApuIdClass
 */
//--------------------------------------------------------
TwinApuIdClass::~TwinApuIdClass()
{
	/*----- PROTECTED REGION ID(TwinApuIdClass::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuIdClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		TwinApuIdClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
TwinApuIdClass *TwinApuIdClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new TwinApuIdClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		TwinApuIdClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
TwinApuIdClass *TwinApuIdClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		AxisStopClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisStopClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisStopClass::execute(): arrived" << endl;
	((static_cast<TwinApuId *>(device))->axis_stop());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		HighEnergyClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *HighEnergyClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "HighEnergyClass::execute(): arrived" << endl;
	((static_cast<TwinApuId *>(device))->high_energy());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		LowEnergyClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *LowEnergyClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "LowEnergyClass::execute(): arrived" << endl;
	((static_cast<TwinApuId *>(device))->low_energy());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		InjectionPositionClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *InjectionPositionClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "InjectionPositionClass::execute(): arrived" << endl;
	((static_cast<TwinApuId *>(device))->injection_position());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AxisInitLowEnergyClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisInitLowEnergyClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisInitLowEnergyClass::execute(): arrived" << endl;
	((static_cast<TwinApuId *>(device))->axis_init_low_energy());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AxisInitHighEnergyClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisInitHighEnergyClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisInitHighEnergyClass::execute(): arrived" << endl;
	((static_cast<TwinApuId *>(device))->axis_init_high_energy());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AxisInitEnergySwitchClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisInitEnergySwitchClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisInitEnergySwitchClass::execute(): arrived" << endl;
	((static_cast<TwinApuId *>(device))->axis_init_energy_switch());
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : TwinApuIdClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum TwinApuIdClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuIdClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum TwinApuIdClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuIdClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum TwinApuIdClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : TwinApuIdClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void TwinApuIdClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "HighEnergyAxisDeviceName";
	prop_desc = "Tango device name of the GalilAxisG2 (axisg2-srv) controlling the position of the High Energy APU";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "LowEnergyAxisDeviceName";
	prop_desc = "Tango device name of the GalilAxisG2 (axisg2-srv) controlling the position of the Low Energy APU";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "EnergySwitchAxisDeviceName";
	prop_desc = "Tango device name of the GalilAxisG2 (axisg2-srv) controlling the switch of High / Low energy APU";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "HighEnergyPosition";
	prop_desc = "HighEnergy threshold of the EnergySwitchAxis [mm]";
	prop_def  = "81.0";
	vect_data.clear();
	vect_data.push_back("81.0");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "LowEnergyPosition";
	prop_desc = "LowEnergy threshold of the EnergySwitchAxis [mm]";
	prop_def  = "-81.0";
	vect_data.clear();
	vect_data.push_back("-81.0");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "HighEnergyPeriod";
	prop_desc = "magnet period of HighEnergy APU [mm]\nUsed to calculate:\ninjection position = HighEnergyPeriod /2\nmaximum position = injection position = HighEnergyPeriod /2";
	prop_def  = "35.56";
	vect_data.clear();
	vect_data.push_back("35.56");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "LowEnergyPeriod";
	prop_desc = "magnet period of LowEnergy APU [mm]\nUsed to calculate:\ninjection position = LowEnergyPeriod /2\nmaximum position = injection position = LowEnergyPeriod /2";
	prop_def  = "55.56";
	vect_data.clear();
	vect_data.push_back("55.56");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "MaxTimeToInjectionPosition";
	prop_desc = "maximum time [s] to reach the injection position";
	prop_def  = "28";
	vect_data.clear();
	vect_data.push_back("28");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "maxTimeToEnergySwitch";
	prop_desc = "maximum tim [s] to perform an energy switch of the APUs";
	prop_def  = "170";
	vect_data.clear();
	vect_data.push_back("170");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "ReadThreadPollTime";
	prop_desc = "polling time for the read thread [ms]";
	prop_def  = "1000";
	vect_data.clear();
	vect_data.push_back("1000");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuIdClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void TwinApuIdClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	//string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("twin-apu-id");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("Tango device e server for Elettra Twin Apu ID (installed on TwinMic beamline) Derived from SupervisedId (cs/cls/supervisedid). The project uses git submodules");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : TwinApuIdClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void TwinApuIdClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(TwinApuIdClass::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuIdClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new TwinApuId(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		TwinApuId *dev = static_cast<TwinApuId *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(TwinApuIdClass::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuIdClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : TwinApuIdClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void TwinApuIdClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(TwinApuIdClass::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuIdClass::attribute_factory_before
	//	Call atribute_factory for inherited class
	SupervisedID_ns::SupervisedIDClass::attribute_factory(att_list);

	//	Attribute : Enabled - Check if not concrete in inherited class
	Tango::Attr *EnabledAttr = get_attr_object_by_name(att_list, "Enabled");
	if (EnabledAttr == NULL)
	{
		//	Attribute : Enabled
		EnabledAttrib	*enabled = new EnabledAttrib();
		Tango::UserDefaultAttrProp	enabled_prop;
		enabled_prop.set_description("True when");
		enabled_prop.set_label("Enabled");
		//	unit	not set for Enabled
		//	standard_unit	not set for Enabled
		//	display_unit	not set for Enabled
		//	format	not set for Enabled
		//	max_value	not set for Enabled
		//	min_value	not set for Enabled
		//	max_alarm	not set for Enabled
		//	min_alarm	not set for Enabled
		//	max_warning	not set for Enabled
		//	min_warning	not set for Enabled
		//	delta_t	not set for Enabled
		//	delta_val	not set for Enabled
		
		enabled->set_default_properties(enabled_prop);
		enabled->set_polling_period(2000);
		enabled->set_disp_level(Tango::OPERATOR);
		//	Not Memorized
		att_list.push_back(enabled);
	}

	//	Attribute : Ready - Check if not concrete in inherited class
	Tango::Attr *ReadyAttr = get_attr_object_by_name(att_list, "Ready");
	if (ReadyAttr == NULL)
	{
		//	Attribute : Ready
		ReadyAttrib	*ready = new ReadyAttrib();
		Tango::UserDefaultAttrProp	ready_prop;
		ready_prop.set_description("true when operating condtions of the ID make it operable by the beamlines:\n- good flags and in range.");
		ready_prop.set_label("ready");
		//	unit	not set for Ready
		//	standard_unit	not set for Ready
		//	display_unit	not set for Ready
		//	format	not set for Ready
		//	max_value	not set for Ready
		//	min_value	not set for Ready
		//	max_alarm	not set for Ready
		//	min_alarm	not set for Ready
		//	max_warning	not set for Ready
		//	min_warning	not set for Ready
		//	delta_t	not set for Ready
		//	delta_val	not set for Ready
		
		ready->set_default_properties(ready_prop);
		ready->set_polling_period(2000);
		ready->set_disp_level(Tango::OPERATOR);
		//	Not Memorized
		att_list.push_back(ready);
	}

	//	Attribute : UserPositionLow
	UserPositionLowAttrib	*userpositionlow = new UserPositionLowAttrib();
	Tango::UserDefaultAttrProp	userpositionlow_prop;
	userpositionlow_prop.set_description("User position of low energy APU");
	userpositionlow_prop.set_label("user postion (low energy)");
	userpositionlow_prop.set_unit("mm");
	userpositionlow_prop.set_standard_unit("1");
	userpositionlow_prop.set_display_unit("mm");
	//	format	not set for UserPositionLow
	//	max_value	not set for UserPositionLow
	//	min_value	not set for UserPositionLow
	//	max_alarm	not set for UserPositionLow
	//	min_alarm	not set for UserPositionLow
	//	max_warning	not set for UserPositionLow
	//	min_warning	not set for UserPositionLow
	//	delta_t	not set for UserPositionLow
	//	delta_val	not set for UserPositionLow
	
	userpositionlow->set_default_properties(userpositionlow_prop);
	//	Not Polled
	userpositionlow->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(userpositionlow);

	//	Attribute : UserPositionHigh
	UserPositionHighAttrib	*userpositionhigh = new UserPositionHighAttrib();
	Tango::UserDefaultAttrProp	userpositionhigh_prop;
	userpositionhigh_prop.set_description("User position of low energy APU");
	userpositionhigh_prop.set_label("user postion (high energy)");
	userpositionhigh_prop.set_unit("mm");
	userpositionhigh_prop.set_standard_unit("1");
	userpositionhigh_prop.set_display_unit("mm");
	//	format	not set for UserPositionHigh
	//	max_value	not set for UserPositionHigh
	//	min_value	not set for UserPositionHigh
	//	max_alarm	not set for UserPositionHigh
	//	min_alarm	not set for UserPositionHigh
	//	max_warning	not set for UserPositionHigh
	//	min_warning	not set for UserPositionHigh
	//	delta_t	not set for UserPositionHigh
	//	delta_val	not set for UserPositionHigh
	
	userpositionhigh->set_default_properties(userpositionhigh_prop);
	//	Not Polled
	userpositionhigh->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(userpositionhigh);

	//	Attribute : HighEnergyAxisState
	HighEnergyAxisStateAttrib	*highenergyaxisstate = new HighEnergyAxisStateAttrib();
	Tango::UserDefaultAttrProp	highenergyaxisstate_prop;
	highenergyaxisstate_prop.set_description("state of the HighEnergy axis device");
	highenergyaxisstate_prop.set_label("high energy axis state");
	//	unit	not set for HighEnergyAxisState
	//	standard_unit	not set for HighEnergyAxisState
	//	display_unit	not set for HighEnergyAxisState
	//	format	not set for HighEnergyAxisState
	//	max_value	not set for HighEnergyAxisState
	//	min_value	not set for HighEnergyAxisState
	//	max_alarm	not set for HighEnergyAxisState
	//	min_alarm	not set for HighEnergyAxisState
	//	max_warning	not set for HighEnergyAxisState
	//	min_warning	not set for HighEnergyAxisState
	//	delta_t	not set for HighEnergyAxisState
	//	delta_val	not set for HighEnergyAxisState
	
	highenergyaxisstate->set_default_properties(highenergyaxisstate_prop);
	//	Not Polled
	highenergyaxisstate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(highenergyaxisstate);

	//	Attribute : LowEnergyAxisState
	LowEnergyAxisStateAttrib	*lowenergyaxisstate = new LowEnergyAxisStateAttrib();
	Tango::UserDefaultAttrProp	lowenergyaxisstate_prop;
	lowenergyaxisstate_prop.set_description("state of the LowEnergy axis device");
	lowenergyaxisstate_prop.set_label("lown energy axis state");
	//	unit	not set for LowEnergyAxisState
	//	standard_unit	not set for LowEnergyAxisState
	//	display_unit	not set for LowEnergyAxisState
	//	format	not set for LowEnergyAxisState
	//	max_value	not set for LowEnergyAxisState
	//	min_value	not set for LowEnergyAxisState
	//	max_alarm	not set for LowEnergyAxisState
	//	min_alarm	not set for LowEnergyAxisState
	//	max_warning	not set for LowEnergyAxisState
	//	min_warning	not set for LowEnergyAxisState
	//	delta_t	not set for LowEnergyAxisState
	//	delta_val	not set for LowEnergyAxisState
	
	lowenergyaxisstate->set_default_properties(lowenergyaxisstate_prop);
	//	Not Polled
	lowenergyaxisstate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(lowenergyaxisstate);

	//	Attribute : EnergySwitchAxisState
	EnergySwitchAxisStateAttrib	*energyswitchaxisstate = new EnergySwitchAxisStateAttrib();
	Tango::UserDefaultAttrProp	energyswitchaxisstate_prop;
	energyswitchaxisstate_prop.set_description("state of the EnergySwitch axis device");
	energyswitchaxisstate_prop.set_label("energy switch axis state");
	//	unit	not set for EnergySwitchAxisState
	//	standard_unit	not set for EnergySwitchAxisState
	//	display_unit	not set for EnergySwitchAxisState
	//	format	not set for EnergySwitchAxisState
	//	max_value	not set for EnergySwitchAxisState
	//	min_value	not set for EnergySwitchAxisState
	//	max_alarm	not set for EnergySwitchAxisState
	//	min_alarm	not set for EnergySwitchAxisState
	//	max_warning	not set for EnergySwitchAxisState
	//	min_warning	not set for EnergySwitchAxisState
	//	delta_t	not set for EnergySwitchAxisState
	//	delta_val	not set for EnergySwitchAxisState
	
	energyswitchaxisstate->set_default_properties(energyswitchaxisstate_prop);
	//	Not Polled
	energyswitchaxisstate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(energyswitchaxisstate);

	//	Attribute : HighEnergyS
	HighEnergySAttrib	*highenergys = new HighEnergySAttrib();
	Tango::UserDefaultAttrProp	highenergys_prop;
	highenergys_prop.set_description("1 if the EnergySwitch Axes is int the HighEnergy Position");
	highenergys_prop.set_label("high energy");
	//	unit	not set for HighEnergyS
	//	standard_unit	not set for HighEnergyS
	//	display_unit	not set for HighEnergyS
	//	format	not set for HighEnergyS
	//	max_value	not set for HighEnergyS
	//	min_value	not set for HighEnergyS
	//	max_alarm	not set for HighEnergyS
	//	min_alarm	not set for HighEnergyS
	//	max_warning	not set for HighEnergyS
	//	min_warning	not set for HighEnergyS
	//	delta_t	not set for HighEnergyS
	//	delta_val	not set for HighEnergyS
	
	highenergys->set_default_properties(highenergys_prop);
	//	Not Polled
	highenergys->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(highenergys);

	//	Attribute : LowEnergyS
	LowEnergySAttrib	*lowenergys = new LowEnergySAttrib();
	Tango::UserDefaultAttrProp	lowenergys_prop;
	lowenergys_prop.set_description("1 if the EnergySwitch Axes is int the LowEnergy Position");
	lowenergys_prop.set_label("low energy");
	//	unit	not set for LowEnergyS
	//	standard_unit	not set for LowEnergyS
	//	display_unit	not set for LowEnergyS
	//	format	not set for LowEnergyS
	//	max_value	not set for LowEnergyS
	//	min_value	not set for LowEnergyS
	//	max_alarm	not set for LowEnergyS
	//	min_alarm	not set for LowEnergyS
	//	max_warning	not set for LowEnergyS
	//	min_warning	not set for LowEnergyS
	//	delta_t	not set for LowEnergyS
	//	delta_val	not set for LowEnergyS
	
	lowenergys->set_default_properties(lowenergys_prop);
	//	Not Polled
	lowenergys->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(lowenergys);

	//	Attribute : HighEnergy
	HighEnergyAttrib	*highenergy = new HighEnergyAttrib();
	Tango::UserDefaultAttrProp	highenergy_prop;
	highenergy_prop.set_description("tue if the EnergySwitch Axes is int the HighEnergy Position");
	highenergy_prop.set_label("high energy");
	//	unit	not set for HighEnergy
	//	standard_unit	not set for HighEnergy
	//	display_unit	not set for HighEnergy
	//	format	not set for HighEnergy
	//	max_value	not set for HighEnergy
	//	min_value	not set for HighEnergy
	//	max_alarm	not set for HighEnergy
	//	min_alarm	not set for HighEnergy
	//	max_warning	not set for HighEnergy
	//	min_warning	not set for HighEnergy
	//	delta_t	not set for HighEnergy
	//	delta_val	not set for HighEnergy
	
	highenergy->set_default_properties(highenergy_prop);
	//	Not Polled
	highenergy->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(highenergy);

	//	Attribute : LowEnergy
	LowEnergyAttrib	*lowenergy = new LowEnergyAttrib();
	Tango::UserDefaultAttrProp	lowenergy_prop;
	lowenergy_prop.set_description("1 if the EnergySwitch Axes is int the LowEnergy Position");
	lowenergy_prop.set_label("low energy");
	//	unit	not set for LowEnergy
	//	standard_unit	not set for LowEnergy
	//	display_unit	not set for LowEnergy
	//	format	not set for LowEnergy
	//	max_value	not set for LowEnergy
	//	min_value	not set for LowEnergy
	//	max_alarm	not set for LowEnergy
	//	min_alarm	not set for LowEnergy
	//	max_warning	not set for LowEnergy
	//	min_warning	not set for LowEnergy
	//	delta_t	not set for LowEnergy
	//	delta_val	not set for LowEnergy
	
	lowenergy->set_default_properties(lowenergy_prop);
	//	Not Polled
	lowenergy->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(lowenergy);

	//	Attribute : EnergySwitchPosition
	EnergySwitchPositionAttrib	*energyswitchposition = new EnergySwitchPositionAttrib();
	Tango::UserDefaultAttrProp	energyswitchposition_prop;
	energyswitchposition_prop.set_description("UserPosition of energy switch motor");
	energyswitchposition_prop.set_label("UserPosition (energy switch)");
	energyswitchposition_prop.set_unit("mm");
	energyswitchposition_prop.set_standard_unit("1");
	energyswitchposition_prop.set_display_unit("mm");
	//	format	not set for EnergySwitchPosition
	//	max_value	not set for EnergySwitchPosition
	//	min_value	not set for EnergySwitchPosition
	//	max_alarm	not set for EnergySwitchPosition
	//	min_alarm	not set for EnergySwitchPosition
	//	max_warning	not set for EnergySwitchPosition
	//	min_warning	not set for EnergySwitchPosition
	//	delta_t	not set for EnergySwitchPosition
	//	delta_val	not set for EnergySwitchPosition
	
	energyswitchposition->set_default_properties(energyswitchposition_prop);
	//	Not Polled
	energyswitchposition->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(energyswitchposition);

	//	Attribute : StatRF - Check if not concrete in inherited class
	Tango::Attr *StatRFAttr = get_attr_object_by_name(att_list, "StatRF");
	if (StatRFAttr == NULL)
	{
		//	Attribute : StatRF
		StatRFAttrib	*statrf = new StatRFAttrib();
		Tango::UserDefaultAttrProp	statrf_prop;
		statrf_prop.set_description("bit mask for compatibility with old style software\nHolds the ready and enabled bits together");
		//	label	not set for StatRF
		//	unit	not set for StatRF
		//	standard_unit	not set for StatRF
		//	display_unit	not set for StatRF
		//	format	not set for StatRF
		//	max_value	not set for StatRF
		//	min_value	not set for StatRF
		//	max_alarm	not set for StatRF
		//	min_alarm	not set for StatRF
		//	max_warning	not set for StatRF
		//	min_warning	not set for StatRF
		//	delta_t	not set for StatRF
		//	delta_val	not set for StatRF
		
		statrf->set_default_properties(statrf_prop);
		statrf->set_polling_period(2000);
		statrf->set_disp_level(Tango::OPERATOR);
		//	Not Memorized
		att_list.push_back(statrf);
	}


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(TwinApuIdClass::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuIdClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : TwinApuIdClass::pipe_factory()
 *	Description : Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void TwinApuIdClass::pipe_factory()
{
	/*----- PROTECTED REGION ID(TwinApuIdClass::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuIdClass::pipe_factory_before
	/*----- PROTECTED REGION ID(TwinApuIdClass::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuIdClass::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : TwinApuIdClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void TwinApuIdClass::command_factory()
{
	/*----- PROTECTED REGION ID(TwinApuIdClass::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuIdClass::command_factory_before
	//	Call command_factory for inherited class
	SupervisedID_ns::SupervisedIDClass::command_factory();



	//	Command AxisStop
	AxisStopClass	*pAxisStopCmd =
		new AxisStopClass("AxisStop",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pAxisStopCmd);

	//	Command HighEnergy
	HighEnergyClass	*pHighEnergyCmd =
		new HighEnergyClass("HighEnergy",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pHighEnergyCmd);

	//	Command LowEnergy
	LowEnergyClass	*pLowEnergyCmd =
		new LowEnergyClass("LowEnergy",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pLowEnergyCmd);

	//	Command InjectionPosition
	InjectionPositionClass	*pInjectionPositionCmd =
		new InjectionPositionClass("InjectionPosition",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pInjectionPositionCmd);

	//	Command AxisInitLowEnergy
	AxisInitLowEnergyClass	*pAxisInitLowEnergyCmd =
		new AxisInitLowEnergyClass("AxisInitLowEnergy",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pAxisInitLowEnergyCmd);

	//	Command AxisInitHighEnergy
	AxisInitHighEnergyClass	*pAxisInitHighEnergyCmd =
		new AxisInitHighEnergyClass("AxisInitHighEnergy",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pAxisInitHighEnergyCmd);

	//	Command AxisInitEnergySwitch
	AxisInitEnergySwitchClass	*pAxisInitEnergySwitchCmd =
		new AxisInitEnergySwitchClass("AxisInitEnergySwitch",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pAxisInitEnergySwitchCmd);

	/*----- PROTECTED REGION ID(TwinApuIdClass::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuIdClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		TwinApuIdClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list
 */
//--------------------------------------------------------
void TwinApuIdClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(TwinApuIdClass::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuIdClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		TwinApuIdClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void TwinApuIdClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		TwinApuId *dev = static_cast<TwinApuId *> (dev_impl);

		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(TwinApuIdClass::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuIdClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuIdClass::get_attr_object_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *TwinApuIdClass::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(TwinApuIdClass::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	TwinApuIdClass::Additional Methods
} //	namespace
