/*----- PROTECTED REGION ID(TwinApuIdStateMachine.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        TwinApuIdStateMachine.cpp
//
// description : State machine file for the TwinApuId class
//
// project :     twin-apu-id
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
// Elettra-Sincrotrone Trieste S.C.p.A. di interesse nazionale
// Strada Statale 14 - km 163,5 in AREA Science Park
// 34149 Basovizza, Trieste ITALY
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <TwinApuId.h>

/*----- PROTECTED REGION END -----*/	//	TwinApuId::TwinApuIdStateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  ON       |  Device OK
//  FAULT    |  Device not working - broken ID
//  UNKNOWN  |  Device not working - unknow reason/condition
//  RUNNING  |  Device gap is moving
//  DISABLE  |  Device not remotely operable
//  MOVING   |  Some Axes are moving
//  STANDBY  |  All motors in standby


namespace TwinApuId_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : TwinApuId::is_Enabled_allowed()
 *	Description : Execution allowed for Enabled attribute
 */
//--------------------------------------------------------
bool TwinApuId::is_Enabled_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Enabled attribute in Write access.
	/*----- PROTECTED REGION ID(TwinApuId::EnabledStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::EnabledStateAllowed_WRITE

	//	Not any excluded states for Enabled attribute in read access.
	/*----- PROTECTED REGION ID(TwinApuId::EnabledStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::EnabledStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuId::is_Ready_allowed()
 *	Description : Execution allowed for Ready attribute
 */
//--------------------------------------------------------
bool TwinApuId::is_Ready_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Ready attribute in read access.
	/*----- PROTECTED REGION ID(TwinApuId::ReadyStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::ReadyStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuId::is_UserPositionLow_allowed()
 *	Description : Execution allowed for UserPositionLow attribute
 */
//--------------------------------------------------------
bool TwinApuId::is_UserPositionLow_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for UserPositionLow attribute in Write access.
	/*----- PROTECTED REGION ID(TwinApuId::UserPositionLowStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::UserPositionLowStateAllowed_WRITE

	//	Not any excluded states for UserPositionLow attribute in read access.
	/*----- PROTECTED REGION ID(TwinApuId::UserPositionLowStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::UserPositionLowStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuId::is_UserPositionHigh_allowed()
 *	Description : Execution allowed for UserPositionHigh attribute
 */
//--------------------------------------------------------
bool TwinApuId::is_UserPositionHigh_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for UserPositionHigh attribute in Write access.
	/*----- PROTECTED REGION ID(TwinApuId::UserPositionHighStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::UserPositionHighStateAllowed_WRITE

	//	Not any excluded states for UserPositionHigh attribute in read access.
	/*----- PROTECTED REGION ID(TwinApuId::UserPositionHighStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::UserPositionHighStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuId::is_HighEnergyAxisState_allowed()
 *	Description : Execution allowed for HighEnergyAxisState attribute
 */
//--------------------------------------------------------
bool TwinApuId::is_HighEnergyAxisState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for HighEnergyAxisState attribute in read access.
	/*----- PROTECTED REGION ID(TwinApuId::HighEnergyAxisStateStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::HighEnergyAxisStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuId::is_LowEnergyAxisState_allowed()
 *	Description : Execution allowed for LowEnergyAxisState attribute
 */
//--------------------------------------------------------
bool TwinApuId::is_LowEnergyAxisState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for LowEnergyAxisState attribute in read access.
	/*----- PROTECTED REGION ID(TwinApuId::LowEnergyAxisStateStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::LowEnergyAxisStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuId::is_EnergySwitchAxisState_allowed()
 *	Description : Execution allowed for EnergySwitchAxisState attribute
 */
//--------------------------------------------------------
bool TwinApuId::is_EnergySwitchAxisState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for EnergySwitchAxisState attribute in read access.
	/*----- PROTECTED REGION ID(TwinApuId::EnergySwitchAxisStateStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::EnergySwitchAxisStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuId::is_HighEnergyS_allowed()
 *	Description : Execution allowed for HighEnergyS attribute
 */
//--------------------------------------------------------
bool TwinApuId::is_HighEnergyS_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for HighEnergyS attribute in read access.
	/*----- PROTECTED REGION ID(TwinApuId::HighEnergySStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::HighEnergySStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuId::is_LowEnergyS_allowed()
 *	Description : Execution allowed for LowEnergyS attribute
 */
//--------------------------------------------------------
bool TwinApuId::is_LowEnergyS_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for LowEnergyS attribute in read access.
	/*----- PROTECTED REGION ID(TwinApuId::LowEnergySStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::LowEnergySStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuId::is_HighEnergy_allowed()
 *	Description : Execution allowed for HighEnergy attribute
 */
//--------------------------------------------------------
bool TwinApuId::is_HighEnergy_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for HighEnergy attribute in read access.
	/*----- PROTECTED REGION ID(TwinApuId::HighEnergyStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::HighEnergyStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuId::is_LowEnergy_allowed()
 *	Description : Execution allowed for LowEnergy attribute
 */
//--------------------------------------------------------
bool TwinApuId::is_LowEnergy_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for LowEnergy attribute in read access.
	/*----- PROTECTED REGION ID(TwinApuId::LowEnergyStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::LowEnergyStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuId::is_EnergySwitchPosition_allowed()
 *	Description : Execution allowed for EnergySwitchPosition attribute
 */
//--------------------------------------------------------
bool TwinApuId::is_EnergySwitchPosition_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for EnergySwitchPosition attribute in read access.
	/*----- PROTECTED REGION ID(TwinApuId::EnergySwitchPositionStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::EnergySwitchPositionStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuId::is_StatRF_allowed()
 *	Description : Execution allowed for StatRF attribute
 */
//--------------------------------------------------------
bool TwinApuId::is_StatRF_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for StatRF attribute in read access.
	/*----- PROTECTED REGION ID(TwinApuId::StatRFStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::StatRFStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : TwinApuId::is_AxisStop_allowed()
 *	Description : Execution allowed for AxisStop attribute
 */
//--------------------------------------------------------
bool TwinApuId::is_AxisStop_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AxisStop command.
	/*----- PROTECTED REGION ID(TwinApuId::AxisStopStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::AxisStopStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuId::is_HighEnergy_allowed()
 *	Description : Execution allowed for HighEnergy attribute
 */
//--------------------------------------------------------
bool TwinApuId::is_HighEnergy_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for HighEnergy command.
	/*----- PROTECTED REGION ID(TwinApuId::HighEnergyStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::HighEnergyStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuId::is_LowEnergy_allowed()
 *	Description : Execution allowed for LowEnergy attribute
 */
//--------------------------------------------------------
bool TwinApuId::is_LowEnergy_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for LowEnergy command.
	/*----- PROTECTED REGION ID(TwinApuId::LowEnergyStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::LowEnergyStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuId::is_InjectionPosition_allowed()
 *	Description : Execution allowed for InjectionPosition attribute
 */
//--------------------------------------------------------
bool TwinApuId::is_InjectionPosition_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for InjectionPosition command.
	/*----- PROTECTED REGION ID(TwinApuId::InjectionPositionStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::InjectionPositionStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuId::is_AxisInitLowEnergy_allowed()
 *	Description : Execution allowed for AxisInitLowEnergy attribute
 */
//--------------------------------------------------------
bool TwinApuId::is_AxisInitLowEnergy_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AxisInitLowEnergy command.
	/*----- PROTECTED REGION ID(TwinApuId::AxisInitLowEnergyStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::AxisInitLowEnergyStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuId::is_AxisInitHighEnergy_allowed()
 *	Description : Execution allowed for AxisInitHighEnergy attribute
 */
//--------------------------------------------------------
bool TwinApuId::is_AxisInitHighEnergy_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AxisInitHighEnergy command.
	/*----- PROTECTED REGION ID(TwinApuId::AxisInitHighEnergyStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::AxisInitHighEnergyStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TwinApuId::is_AxisInitEnergySwitch_allowed()
 *	Description : Execution allowed for AxisInitEnergySwitch attribute
 */
//--------------------------------------------------------
bool TwinApuId::is_AxisInitEnergySwitch_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AxisInitEnergySwitch command.
	/*----- PROTECTED REGION ID(TwinApuId::AxisInitEnergySwitchStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	TwinApuId::AxisInitEnergySwitchStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(TwinApuId::TwinApuIdStateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	TwinApuId::TwinApuIdStateAllowed.AdditionalMethods

}	//	End of namespace
